/* Meiga.c generated by valac, the Vala compiler
 * generated from Meiga.vala, do not modify */

/* Meiga - Lightweight and easy to use web file server for your desktop
 *
 * Copyright (C) 2009 Igalia, S.L.
 *
 * Authors:
 *
 * Igalia, S.L. <info@igalia.com>
 * Enrique Ocaña González <eocanha@igalia.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <dbus/dbus.h>
#include <dbus/dbus-glib.h>
#include <dbus/dbus-glib-lowlevel.h>


#define TYPE_MEIGA (meiga_get_type ())
#define MEIGA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEIGA, Meiga))
#define MEIGA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEIGA, MeigaClass))
#define IS_MEIGA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEIGA))
#define IS_MEIGA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEIGA))
#define MEIGA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEIGA, MeigaClass))

typedef struct _Meiga Meiga;
typedef struct _MeigaClass MeigaClass;
typedef struct _MeigaPrivate MeigaPrivate;

#define TYPE_MEIGA_SERVER (meiga_server_get_type ())
#define MEIGA_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEIGA_SERVER, MeigaServer))
#define MEIGA_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEIGA_SERVER, MeigaServerClass))
#define IS_MEIGA_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEIGA_SERVER))
#define IS_MEIGA_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEIGA_SERVER))
#define MEIGA_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEIGA_SERVER, MeigaServerClass))

typedef struct _MeigaServer MeigaServer;
typedef struct _MeigaServerClass MeigaServerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_LOG (log_get_type ())
#define LOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOG, Log))
#define LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOG, LogClass))
#define IS_LOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOG))
#define IS_LOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOG))
#define LOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOG, LogClass))

typedef struct _Log Log;
typedef struct _LogClass LogClass;
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _DBusObjectVTable _DBusObjectVTable;

struct _Meiga {
	GObject parent_instance;
	MeigaPrivate * priv;
};

struct _MeigaClass {
	GObjectClass parent_class;
};

struct _MeigaPrivate {
	MeigaServer* server;
};

struct _DBusObjectVTable {
	void (*register_object) (DBusConnection*, const char*, void*);
};


static gpointer meiga_parent_class = NULL;

GType meiga_get_type (void);
GType meiga_server_get_type (void);
#define MEIGA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MEIGA, MeigaPrivate))
enum  {
	MEIGA_DUMMY_PROPERTY
};
GType log_get_type (void);
Log* meiga_server_get_logger (MeigaServer* self);
static void _lambda0_ (Log* o, Meiga* self);
static void __lambda0__log_changed (Log* _sender, gpointer self);
static void _lambda1_ (MeigaServer* o, Meiga* self);
static void __lambda1__meiga_server_model_changed (MeigaServer* _sender, gpointer self);
Meiga* meiga_new (MeigaServer* server);
Meiga* meiga_construct (GType object_type, MeigaServer* server);
void meiga_server_register_path (MeigaServer* self, const char* real_path, const char* logical_path);
void meiga_register_path (Meiga* self, const char* real_path, const char* logical_path);
void meiga_server_unregister_path (MeigaServer* self, const char* logical_path);
void meiga_unregister_path (Meiga* self, const char* logical_path);
guint meiga_server_get_gui_pid (MeigaServer* self);
guint meiga_get_gui_pid (Meiga* self);
const char* meiga_server_get_display (MeigaServer* self);
char* meiga_get_display (Meiga* self);
void meiga_server_register_gui (MeigaServer* self, guint gui_pid, const char* display);
void meiga_register_gui (Meiga* self, guint gui_pid, const char* display);
GHashTable* meiga_server_get_paths (MeigaServer* self);
GHashTable* meiga_get_paths (Meiga* self);
char* meiga_get_paths_as_string (Meiga* self);
char* meiga_server_get_public_url (MeigaServer* self);
char* meiga_get_public_url (Meiga* self);
gint meiga_server_get_redirection_type (MeigaServer* self);
gint meiga_get_redirection_type (Meiga* self);
void meiga_server_set_redirection_type (MeigaServer* self, gint redirection_type);
void meiga_set_redirection_type (Meiga* self, gint redirection_type);
gint meiga_server_get_redirection_status (MeigaServer* self);
gint meiga_get_redirection_status (Meiga* self);
guint meiga_server_get_port (MeigaServer* self);
guint meiga_get_port (Meiga* self);
void meiga_server_set_port (MeigaServer* self, guint value);
void meiga_set_port (Meiga* self, guint port);
gboolean meiga_server_get_ssl (MeigaServer* self);
gboolean meiga_get_ssl (Meiga* self);
void meiga_server_set_ssl (MeigaServer* self, gboolean value);
void meiga_set_ssl (Meiga* self, gboolean ssl);
const char* meiga_server_get_auth_user (MeigaServer* self);
char* meiga_get_auth_user (Meiga* self);
void meiga_server_set_auth_user (MeigaServer* self, const char* value);
void meiga_set_auth_user (Meiga* self, const char* auth_user);
const char* meiga_server_get_auth_md5passwd (MeigaServer* self);
char* meiga_get_auth_md5passwd (Meiga* self);
void meiga_server_set_auth_md5passwd (MeigaServer* self, const char* value);
void meiga_set_auth_md5passwd (Meiga* self, const char* auth_md5passwd);
void meiga_server_set_ssh_host (MeigaServer* self, const char* ssh_host);
void meiga_set_ssh_host (Meiga* self, const char* ssh_host);
void meiga_server_set_ssh_port (MeigaServer* self, const char* ssh_port);
void meiga_set_ssh_port (Meiga* self, const char* ssh_port);
void meiga_server_set_ssh_user (MeigaServer* self, const char* ssh_user);
void meiga_set_ssh_user (Meiga* self, const char* ssh_user);
void meiga_server_set_ssh_password (MeigaServer* self, const char* ssh_password);
void meiga_set_ssh_password (Meiga* self, const char* ssh_password);
void meiga_server_shutdown (MeigaServer* self);
void meiga_shutdown (Meiga* self);
char* log_get_pending (Log* self, guint start);
char* meiga_get_pending_log (Meiga* self, guint start);
char* meiga_server_get_requests_stats (MeigaServer* self);
char* meiga_get_requests_stats (Meiga* self);
void meiga_dbus_register_object (DBusConnection* connection, const char* path, void* object);
void _meiga_dbus_unregister (DBusConnection* connection, void* _user_data_);
DBusHandlerResult meiga_dbus_message (DBusConnection* connection, DBusMessage* message, void* object);
static DBusHandlerResult _dbus_meiga_introspect (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_property_get_all (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_register_path (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_unregister_path (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_gui_pid (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_display (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_register_gui (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_paths (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_paths_as_string (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_public_url (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_redirection_type (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_redirection_type (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_redirection_status (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_port (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_port (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_ssl (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_ssl (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_auth_user (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_auth_user (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_auth_md5passwd (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_auth_md5passwd (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_ssh_host (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_ssh_port (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_ssh_user (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_set_ssh_password (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_shutdown (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_pending_log (Meiga* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_meiga_get_requests_stats (Meiga* self, DBusConnection* connection, DBusMessage* message);
static void _dbus_meiga_model_changed (GObject* _sender, DBusConnection* _connection);
static void _dbus_meiga_log_changed (GObject* _sender, DBusConnection* _connection);
static void meiga_finalize (GObject* obj);
static void _vala_dbus_register_object (DBusConnection* connection, const char* path, void* object);
static void _vala_dbus_unregister_object (gpointer connection, GObject* object);

static const DBusObjectPathVTable _meiga_dbus_path_vtable = {_meiga_dbus_unregister, meiga_dbus_message};
static const _DBusObjectVTable _meiga_dbus_vtable = {meiga_dbus_register_object};


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _lambda0_ (Log* o, Meiga* self) {
	g_return_if_fail (o != NULL);
	g_signal_emit_by_name (self, "log-changed");
}


static void __lambda0__log_changed (Log* _sender, gpointer self) {
	_lambda0_ (_sender, self);
}


static void _lambda1_ (MeigaServer* o, Meiga* self) {
	g_return_if_fail (o != NULL);
	g_signal_emit_by_name (self, "model-changed");
}


static void __lambda1__meiga_server_model_changed (MeigaServer* _sender, gpointer self) {
	_lambda1_ (_sender, self);
}


Meiga* meiga_construct (GType object_type, MeigaServer* server) {
	Meiga * self;
	MeigaServer* _tmp0_;
	g_return_val_if_fail (server != NULL, NULL);
	self = (Meiga*) g_object_new (object_type, NULL);
	self->priv->server = (_tmp0_ = _g_object_ref0 (server), _g_object_unref0 (self->priv->server), _tmp0_);
	if (meiga_server_get_logger (self->priv->server) != NULL) {
		g_signal_connect_object (meiga_server_get_logger (self->priv->server), "changed", (GCallback) __lambda0__log_changed, self, 0);
	}
	g_signal_connect_object (self->priv->server, "model-changed", (GCallback) __lambda1__meiga_server_model_changed, self, 0);
	return self;
}


Meiga* meiga_new (MeigaServer* server) {
	return meiga_construct (TYPE_MEIGA, server);
}


void meiga_register_path (Meiga* self, const char* real_path, const char* logical_path) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (real_path != NULL);
	g_return_if_fail (logical_path != NULL);
	meiga_server_register_path (self->priv->server, real_path, logical_path);
	g_signal_emit_by_name (self, "model-changed");
}


void meiga_unregister_path (Meiga* self, const char* logical_path) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (logical_path != NULL);
	meiga_server_unregister_path (self->priv->server, logical_path);
	g_signal_emit_by_name (self, "model-changed");
}


guint meiga_get_gui_pid (Meiga* self) {
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = meiga_server_get_gui_pid (self->priv->server);
	return result;
}


char* meiga_get_display (Meiga* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup (meiga_server_get_display (self->priv->server));
	return result;
}


void meiga_register_gui (Meiga* self, guint gui_pid, const char* display) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (display != NULL);
	meiga_server_register_gui (self->priv->server, gui_pid, display);
}


GHashTable* meiga_get_paths (Meiga* self) {
	GHashTable* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = meiga_server_get_paths (self->priv->server);
	return result;
}


char* meiga_get_paths_as_string (Meiga* self) {
	char* result = NULL;
	GHashTable* t;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* keys;
	char* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	t = meiga_server_get_paths (self->priv->server);
	keys = (_tmp1_ = g_list_copy (_tmp0_ = g_hash_table_get_keys (t)), _g_list_free0 (_tmp0_), _tmp1_);
	keys = g_list_sort (keys, strcmp);
	_result_ = g_strdup ("");
	{
		GList* k_collection;
		GList* k_it;
		k_collection = keys;
		for (k_it = k_collection; k_it != NULL; k_it = k_it->next) {
			const char* k;
			k = (const char*) k_it->data;
			{
				char* v;
				char* _tmp5_;
				char* _tmp4_;
				char* _tmp3_;
				char* _tmp2_;
				v = g_strdup ((const char*) g_hash_table_lookup (t, k));
				_result_ = (_tmp5_ = g_strconcat (_result_, _tmp4_ = g_strconcat (_tmp3_ = g_strconcat (_tmp2_ = g_strconcat (k, "\t", NULL), v, NULL), "\n", NULL), NULL), _g_free0 (_result_), _tmp5_);
				_g_free0 (_tmp4_);
				_g_free0 (_tmp3_);
				_g_free0 (_tmp2_);
				_g_free0 (v);
			}
		}
	}
	result = _result_;
	_g_hash_table_unref0 (t);
	_g_list_free0 (keys);
	return result;
}


char* meiga_get_public_url (Meiga* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = meiga_server_get_public_url (self->priv->server);
	return result;
}


gint meiga_get_redirection_type (Meiga* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = meiga_server_get_redirection_type (self->priv->server);
	return result;
}


void meiga_set_redirection_type (Meiga* self, gint redirection_type) {
	g_return_if_fail (self != NULL);
	meiga_server_set_redirection_type (self->priv->server, redirection_type);
}


gint meiga_get_redirection_status (Meiga* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = meiga_server_get_redirection_status (self->priv->server);
	return result;
}


guint meiga_get_port (Meiga* self) {
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = meiga_server_get_port (self->priv->server);
	return result;
}


void meiga_set_port (Meiga* self, guint port) {
	g_return_if_fail (self != NULL);
	meiga_server_set_port (self->priv->server, port);
}


gboolean meiga_get_ssl (Meiga* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = meiga_server_get_ssl (self->priv->server);
	return result;
}


void meiga_set_ssl (Meiga* self, gboolean ssl) {
	g_return_if_fail (self != NULL);
	meiga_server_set_ssl (self->priv->server, ssl);
}


char* meiga_get_auth_user (Meiga* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup (meiga_server_get_auth_user (self->priv->server));
	return result;
}


void meiga_set_auth_user (Meiga* self, const char* auth_user) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (auth_user != NULL);
	meiga_server_set_auth_user (self->priv->server, auth_user);
}


char* meiga_get_auth_md5passwd (Meiga* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup (meiga_server_get_auth_md5passwd (self->priv->server));
	return result;
}


void meiga_set_auth_md5passwd (Meiga* self, const char* auth_md5passwd) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (auth_md5passwd != NULL);
	meiga_server_set_auth_md5passwd (self->priv->server, auth_md5passwd);
}


void meiga_set_ssh_host (Meiga* self, const char* ssh_host) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (ssh_host != NULL);
	meiga_server_set_ssh_host (self->priv->server, ssh_host);
}


void meiga_set_ssh_port (Meiga* self, const char* ssh_port) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (ssh_port != NULL);
	meiga_server_set_ssh_port (self->priv->server, ssh_port);
}


void meiga_set_ssh_user (Meiga* self, const char* ssh_user) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (ssh_user != NULL);
	meiga_server_set_ssh_user (self->priv->server, ssh_user);
}


void meiga_set_ssh_password (Meiga* self, const char* ssh_password) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (ssh_password != NULL);
	meiga_server_set_ssh_password (self->priv->server, ssh_password);
}


void meiga_shutdown (Meiga* self) {
	g_return_if_fail (self != NULL);
	meiga_server_shutdown (self->priv->server);
}


char* meiga_get_pending_log (Meiga* self, guint start) {
	char* result = NULL;
	char* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = NULL;
	if (meiga_server_get_logger (self->priv->server) != NULL) {
		char* _tmp0_;
		_result_ = (_tmp0_ = log_get_pending (meiga_server_get_logger (self->priv->server), start), _g_free0 (_result_), _tmp0_);
	} else {
		if (start == 0) {
			char* _tmp1_;
			_result_ = (_tmp1_ = g_strdup (_ ("--- No log available ---")), _g_free0 (_result_), _tmp1_);
		} else {
			char* _tmp2_;
			_result_ = (_tmp2_ = g_strdup (""), _g_free0 (_result_), _tmp2_);
		}
	}
	result = _result_;
	return result;
}


char* meiga_get_requests_stats (Meiga* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = meiga_server_get_requests_stats (self->priv->server);
	return result;
}


void _meiga_dbus_unregister (DBusConnection* connection, void* _user_data_) {
}


static DBusHandlerResult _dbus_meiga_introspect (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter;
	GString* xml_data;
	char** children;
	int i;
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	xml_data = g_string_new ("<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\" \"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n");
	g_string_append (xml_data, "<node>\n<interface name=\"org.freedesktop.DBus.Introspectable\">\n  <method name=\"Introspect\">\n    <arg name=\"data\" direction=\"out\" type=\"s\"/>\n  </method>\n</interface>\n<interface name=\"org.freedesktop.DBus.Properties\">\n  <method name=\"Get\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"out\" type=\"v\"/>\n  </method>\n  <method name=\"Set\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"in\" type=\"v\"/>\n  </method>\n  <method name=\"GetAll\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"props\" direction=\"out\" type=\"a{sv}\"/>\n  </method>\n</interface>\n<interface name=\"com.igalia.Meiga\">\n  <method name=\"RegisterPath\">\n    <arg name=\"real_path\" type=\"s\" direction=\"in\"/>\n    <arg name=\"logical_path\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"UnregisterPath\">\n    <arg name=\"logical_path\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"GetGuiPid\">\n    <arg name=\"result\" type=\"u\" direction=\"out\"/>\n  </method>\n  <method name=\"GetDisplay\">\n    <arg name=\"result\" type=\"s\" direction=\"out\"/>\n  </method>\n  <method name=\"RegisterGui\">\n    <arg name=\"gui_pid\" type=\"u\" direction=\"in\"/>\n    <arg name=\"display\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"GetPaths\">\n    <arg name=\"result\" type=\"a{ss}\" direction=\"out\"/>\n  </method>\n  <method name=\"GetPathsAsString\">\n    <arg name=\"result\" type=\"s\" direction=\"out\"/>\n  </method>\n  <method name=\"GetPublicUrl\">\n    <arg name=\"result\" type=\"s\" direction=\"out\"/>\n  </method>\n  <method name=\"GetRedirectionType\">\n    <arg name=\"result\" type=\"i\" direction=\"out\"/>\n  </method>\n  <method name=\"SetRedirectionType\">\n    <arg name=\"redirection_type\" type=\"i\" direction=\"in\"/>\n  </method>\n  <method name=\"GetRedirectionStatus\">\n    <arg name=\"result\" type=\"i\" direction=\"out\"/>\n  </method>\n  <method name=\"GetPort\">\n    <arg name=\"result\" type=\"u\" direction=\"out\"/>\n  </method>\n  <method name=\"SetPort\">\n    <arg name=\"port\" type=\"u\" direction=\"in\"/>\n  </method>\n  <method name=\"GetSsl\">\n    <arg name=\"result\" type=\"b\" direction=\"out\"/>\n  </method>\n  <method name=\"SetSsl\">\n    <arg name=\"ssl\" type=\"b\" direction=\"in\"/>\n  </method>\n  <method name=\"GetAuthUser\">\n    <arg name=\"result\" type=\"s\" direction=\"out\"/>\n  </method>\n  <method name=\"SetAuthUser\">\n    <arg name=\"auth_user\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"GetAuthMd5passwd\">\n    <arg name=\"result\" type=\"s\" direction=\"out\"/>\n  </method>\n  <method name=\"SetAuthMd5passwd\">\n    <arg name=\"auth_md5passwd\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"SetSshHost\">\n    <arg name=\"ssh_host\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"SetSshPort\">\n    <arg name=\"ssh_port\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"SetSshUser\">\n    <arg name=\"ssh_user\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"SetSshPassword\">\n    <arg name=\"ssh_password\" type=\"s\" direction=\"in\"/>\n  </method>\n  <method name=\"Shutdown\">\n  </method>\n  <method name=\"GetPendingLog\">\n    <arg name=\"start\" type=\"u\" direction=\"in\"/>\n    <arg name=\"result\" type=\"s\" direction=\"out\"/>\n  </method>\n  <method name=\"GetRequestsStats\">\n    <arg name=\"result\" type=\"s\" direction=\"out\"/>\n  </method>\n  <signal name=\"ModelChanged\">\n  </signal>\n  <signal name=\"LogChanged\">\n  </signal>\n</interface>\n");
	dbus_connection_list_registered (connection, g_object_get_data ((GObject *) self, "dbus_object_path"), &children);
	for (i = 0; children[i]; i++) {
		g_string_append_printf (xml_data, "<node name=\"%s\"/>\n", children[i]);
	}
	dbus_free_string_array (children);
	g_string_append (xml_data, "</node>\n");
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &xml_data->str);
	g_string_free (xml_data, TRUE);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_property_get_all (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter, reply_iter, subiter;
	char* interface_name;
	const char* _tmp0_;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &reply_iter);
	dbus_message_iter_get_basic (&iter, &_tmp0_);
	dbus_message_iter_next (&iter);
	interface_name = g_strdup (_tmp0_);
	if (strcmp (interface_name, "com.igalia.Meiga") == 0) {
		dbus_message_iter_open_container (&reply_iter, DBUS_TYPE_ARRAY, "{sv}", &subiter);
		dbus_message_iter_close_container (&reply_iter, &subiter);
	} else {
		dbus_message_unref (reply);
		reply = NULL;
	}
	g_free (interface_name);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_register_path (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* real_path = NULL;
	const char* _tmp1_;
	char* logical_path = NULL;
	const char* _tmp2_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "ss")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp1_);
	dbus_message_iter_next (&iter);
	real_path = g_strdup (_tmp1_);
	dbus_message_iter_get_basic (&iter, &_tmp2_);
	dbus_message_iter_next (&iter);
	logical_path = g_strdup (_tmp2_);
	meiga_register_path (self, real_path, logical_path);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (real_path);
	_g_free0 (logical_path);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_unregister_path (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* logical_path = NULL;
	const char* _tmp3_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp3_);
	dbus_message_iter_next (&iter);
	logical_path = g_strdup (_tmp3_);
	meiga_unregister_path (self, logical_path);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (logical_path);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_gui_pid (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	guint result;
	DBusMessage* reply;
	dbus_uint32_t _tmp4_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_gui_pid (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp4_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_UINT32, &_tmp4_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_display (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* result;
	DBusMessage* reply;
	const char* _tmp5_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_display (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp5_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &_tmp5_);
	_g_free0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_register_gui (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	guint gui_pid = 0U;
	dbus_uint32_t _tmp6_;
	char* display = NULL;
	const char* _tmp7_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "us")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp6_);
	dbus_message_iter_next (&iter);
	gui_pid = _tmp6_;
	dbus_message_iter_get_basic (&iter, &_tmp7_);
	dbus_message_iter_next (&iter);
	display = g_strdup (_tmp7_);
	meiga_register_gui (self, gui_pid, display);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (display);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_paths (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	GHashTable* result;
	DBusMessage* reply;
	DBusMessageIter _tmp8_, _tmp9_;
	GHashTableIter _tmp10_;
	gpointer _tmp11_, _tmp12_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_paths (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "{ss}", &_tmp8_);
	g_hash_table_iter_init (&_tmp10_, result);
	while (g_hash_table_iter_next (&_tmp10_, &_tmp11_, &_tmp12_)) {
		char* _key;
		char* _value;
		const char* _tmp13_;
		const char* _tmp14_;
		dbus_message_iter_open_container (&_tmp8_, DBUS_TYPE_DICT_ENTRY, NULL, &_tmp9_);
		_key = (char*) _tmp11_;
		_value = (char*) _tmp12_;
		_tmp13_ = _key;
		dbus_message_iter_append_basic (&_tmp9_, DBUS_TYPE_STRING, &_tmp13_);
		_tmp14_ = _value;
		dbus_message_iter_append_basic (&_tmp9_, DBUS_TYPE_STRING, &_tmp14_);
		dbus_message_iter_close_container (&_tmp8_, &_tmp9_);
	}
	dbus_message_iter_close_container (&iter, &_tmp8_);
	_g_hash_table_unref0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_paths_as_string (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* result;
	DBusMessage* reply;
	const char* _tmp15_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_paths_as_string (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp15_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &_tmp15_);
	_g_free0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_public_url (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* result;
	DBusMessage* reply;
	const char* _tmp16_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_public_url (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp16_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &_tmp16_);
	_g_free0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_redirection_type (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint result;
	DBusMessage* reply;
	dbus_int32_t _tmp17_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_redirection_type (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp17_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &_tmp17_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_redirection_type (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint redirection_type = 0;
	dbus_int32_t _tmp18_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "i")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp18_);
	dbus_message_iter_next (&iter);
	redirection_type = _tmp18_;
	meiga_set_redirection_type (self, redirection_type);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_redirection_status (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint result;
	DBusMessage* reply;
	dbus_int32_t _tmp19_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_redirection_status (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp19_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &_tmp19_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_port (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	guint result;
	DBusMessage* reply;
	dbus_uint32_t _tmp20_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_port (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp20_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_UINT32, &_tmp20_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_port (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	guint port = 0U;
	dbus_uint32_t _tmp21_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "u")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp21_);
	dbus_message_iter_next (&iter);
	port = _tmp21_;
	meiga_set_port (self, port);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_ssl (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gboolean result;
	DBusMessage* reply;
	dbus_bool_t _tmp22_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_ssl (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp22_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_BOOLEAN, &_tmp22_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_ssl (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gboolean ssl = FALSE;
	dbus_bool_t _tmp23_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "b")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp23_);
	dbus_message_iter_next (&iter);
	ssl = _tmp23_;
	meiga_set_ssl (self, ssl);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_auth_user (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* result;
	DBusMessage* reply;
	const char* _tmp24_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_auth_user (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp24_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &_tmp24_);
	_g_free0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_auth_user (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* auth_user = NULL;
	const char* _tmp25_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp25_);
	dbus_message_iter_next (&iter);
	auth_user = g_strdup (_tmp25_);
	meiga_set_auth_user (self, auth_user);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (auth_user);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_auth_md5passwd (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* result;
	DBusMessage* reply;
	const char* _tmp26_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_auth_md5passwd (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp26_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &_tmp26_);
	_g_free0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_auth_md5passwd (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* auth_md5passwd = NULL;
	const char* _tmp27_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp27_);
	dbus_message_iter_next (&iter);
	auth_md5passwd = g_strdup (_tmp27_);
	meiga_set_auth_md5passwd (self, auth_md5passwd);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (auth_md5passwd);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_ssh_host (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* ssh_host = NULL;
	const char* _tmp28_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp28_);
	dbus_message_iter_next (&iter);
	ssh_host = g_strdup (_tmp28_);
	meiga_set_ssh_host (self, ssh_host);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (ssh_host);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_ssh_port (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* ssh_port = NULL;
	const char* _tmp29_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp29_);
	dbus_message_iter_next (&iter);
	ssh_port = g_strdup (_tmp29_);
	meiga_set_ssh_port (self, ssh_port);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (ssh_port);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_ssh_user (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* ssh_user = NULL;
	const char* _tmp30_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp30_);
	dbus_message_iter_next (&iter);
	ssh_user = g_strdup (_tmp30_);
	meiga_set_ssh_user (self, ssh_user);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (ssh_user);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_set_ssh_password (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* ssh_password = NULL;
	const char* _tmp31_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp31_);
	dbus_message_iter_next (&iter);
	ssh_password = g_strdup (_tmp31_);
	meiga_set_ssh_password (self, ssh_password);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (ssh_password);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_shutdown (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	meiga_shutdown (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_pending_log (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	guint start = 0U;
	dbus_uint32_t _tmp32_;
	char* result;
	DBusMessage* reply;
	const char* _tmp33_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "u")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp32_);
	dbus_message_iter_next (&iter);
	start = _tmp32_;
	result = meiga_get_pending_log (self, start);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp33_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &_tmp33_);
	_g_free0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_meiga_get_requests_stats (Meiga* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* result;
	DBusMessage* reply;
	const char* _tmp34_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = meiga_get_requests_stats (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp34_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &_tmp34_);
	_g_free0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


DBusHandlerResult meiga_dbus_message (DBusConnection* connection, DBusMessage* message, void* object) {
	DBusHandlerResult result;
	result = DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Introspectable", "Introspect")) {
		result = _dbus_meiga_introspect (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Properties", "GetAll")) {
		result = _dbus_meiga_property_get_all (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "RegisterPath")) {
		result = _dbus_meiga_register_path (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "UnregisterPath")) {
		result = _dbus_meiga_unregister_path (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetGuiPid")) {
		result = _dbus_meiga_get_gui_pid (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetDisplay")) {
		result = _dbus_meiga_get_display (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "RegisterGui")) {
		result = _dbus_meiga_register_gui (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetPaths")) {
		result = _dbus_meiga_get_paths (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetPathsAsString")) {
		result = _dbus_meiga_get_paths_as_string (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetPublicUrl")) {
		result = _dbus_meiga_get_public_url (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetRedirectionType")) {
		result = _dbus_meiga_get_redirection_type (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetRedirectionType")) {
		result = _dbus_meiga_set_redirection_type (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetRedirectionStatus")) {
		result = _dbus_meiga_get_redirection_status (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetPort")) {
		result = _dbus_meiga_get_port (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetPort")) {
		result = _dbus_meiga_set_port (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetSsl")) {
		result = _dbus_meiga_get_ssl (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetSsl")) {
		result = _dbus_meiga_set_ssl (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetAuthUser")) {
		result = _dbus_meiga_get_auth_user (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetAuthUser")) {
		result = _dbus_meiga_set_auth_user (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetAuthMd5passwd")) {
		result = _dbus_meiga_get_auth_md5passwd (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetAuthMd5passwd")) {
		result = _dbus_meiga_set_auth_md5passwd (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetSshHost")) {
		result = _dbus_meiga_set_ssh_host (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetSshPort")) {
		result = _dbus_meiga_set_ssh_port (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetSshUser")) {
		result = _dbus_meiga_set_ssh_user (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "SetSshPassword")) {
		result = _dbus_meiga_set_ssh_password (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "Shutdown")) {
		result = _dbus_meiga_shutdown (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetPendingLog")) {
		result = _dbus_meiga_get_pending_log (object, connection, message);
	} else if (dbus_message_is_method_call (message, "com.igalia.Meiga", "GetRequestsStats")) {
		result = _dbus_meiga_get_requests_stats (object, connection, message);
	}
	if (result == DBUS_HANDLER_RESULT_HANDLED) {
		return result;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static void _dbus_meiga_model_changed (GObject* _sender, DBusConnection* _connection) {
	const char * _path;
	DBusMessage *_message;
	DBusMessageIter _iter;
	_path = g_object_get_data (_sender, "dbus_object_path");
	_message = dbus_message_new_signal (_path, "com.igalia.Meiga", "ModelChanged");
	dbus_message_iter_init_append (_message, &_iter);
	dbus_connection_send (_connection, _message, NULL);
	dbus_message_unref (_message);
}


static void _dbus_meiga_log_changed (GObject* _sender, DBusConnection* _connection) {
	const char * _path;
	DBusMessage *_message;
	DBusMessageIter _iter;
	_path = g_object_get_data (_sender, "dbus_object_path");
	_message = dbus_message_new_signal (_path, "com.igalia.Meiga", "LogChanged");
	dbus_message_iter_init_append (_message, &_iter);
	dbus_connection_send (_connection, _message, NULL);
	dbus_message_unref (_message);
}


void meiga_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	if (!g_object_get_data (object, "dbus_object_path")) {
		g_object_set_data (object, "dbus_object_path", g_strdup (path));
		dbus_connection_register_object_path (connection, path, &_meiga_dbus_path_vtable, object);
		g_object_weak_ref (object, _vala_dbus_unregister_object, connection);
	}
	g_signal_connect (object, "model-changed", (GCallback) _dbus_meiga_model_changed, connection);
	g_signal_connect (object, "log-changed", (GCallback) _dbus_meiga_log_changed, connection);
}


static void meiga_class_init (MeigaClass * klass) {
	meiga_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MeigaPrivate));
	G_OBJECT_CLASS (klass)->finalize = meiga_finalize;
	g_signal_new ("model_changed", TYPE_MEIGA, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("log_changed", TYPE_MEIGA, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_type_set_qdata (TYPE_MEIGA, g_quark_from_static_string ("DBusObjectVTable"), (void*) (&_meiga_dbus_vtable));
}


static void meiga_instance_init (Meiga * self) {
	self->priv = MEIGA_GET_PRIVATE (self);
}


static void meiga_finalize (GObject* obj) {
	Meiga * self;
	self = MEIGA (obj);
	_g_object_unref0 (self->priv->server);
	G_OBJECT_CLASS (meiga_parent_class)->finalize (obj);
}


GType meiga_get_type (void) {
	static volatile gsize meiga_type_id__volatile = 0;
	if (g_once_init_enter (&meiga_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MeigaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) meiga_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Meiga), 0, (GInstanceInitFunc) meiga_instance_init, NULL };
		GType meiga_type_id;
		meiga_type_id = g_type_register_static (G_TYPE_OBJECT, "Meiga", &g_define_type_info, 0);
		g_once_init_leave (&meiga_type_id__volatile, meiga_type_id);
	}
	return meiga_type_id__volatile;
}


static void _vala_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	const _DBusObjectVTable * vtable;
	vtable = g_type_get_qdata (G_TYPE_FROM_INSTANCE (object), g_quark_from_static_string ("DBusObjectVTable"));
	if (vtable) {
		vtable->register_object (connection, path, object);
	} else {
		g_warning ("Object does not implement any D-Bus interface");
	}
}


static void _vala_dbus_unregister_object (gpointer connection, GObject* object) {
	char* path;
	path = g_object_steal_data ((GObject*) object, "dbus_object_path");
	dbus_connection_unregister_object_path (connection, path);
	g_free (path);
}




